/* Exercise 6.22 */
/* This program reads the last month's sales information */
/* and summarize the total sales by salesperson by product */

#include <stdio.h>
#include <conio.h>

main()
{
unsigned long int sales [4][5];
long int totalCash;
int salesPersonNo, productNo, i, j, entryCount = 0;

 for ( i = 0 ; i <= 3 ; i++ )               /* initialize the sales array */
  for ( j = 0 ; j <= 4 ; j++ )
   sales [i][j] = 0;

 clrscr();
 printf("\nEnter salesperson no, product no, "
	"total cash earned (enter -13 to exit):\n");
 scanf("%d %d %ld", &salesPersonNo, &productNo, &totalCash);

 while ( (salesPersonNo != -13) &&
	 (productNo != -13) &&
	 (totalCash != -13) )            /* loop until user wants to exit */
  {
   if ( (salesPersonNo >= 1) && (salesPersonNo <= 4) &&
	(productNo >= 1) && (productNo <= 5) &&
	(totalCash >= 0) )                      /* check the input bounds */
    {
     sales [salesPersonNo-1][productNo-1] += (unsigned) totalCash;
     entryCount++;                       /* increase the input entry flag */
    }
   else
    printf("\n\aInvalid data entry! Please check the boundaries...\n\n");

   printf("\nEnter salesperson no, product no, total cash earned (enter -13 to exit):\n");
   scanf("%d %d %ld", &salesPersonNo, &productNo, &totalCash);
  } /* end of while */

 if (entryCount > 0)                              /* if there is input... */
  {                                                   /* print the result */
   clrscr();
   printf("\n\n\n%26s%13s%13s%13s%14s","Person 1","Person 2","Person 3",
	  "Person 4","  Total ($)");
   printf("\n%27s%13s%13s%13s%13s","----------","----------","----------",
	  "----------"," ----------");

  for ( i = 0 ; i <= 4 ; i++ )
   {
    printf("\n%68s","");
    printf("\nProduct %d ($): %11lu%13lu%13lu%13lu  %10lu", ( i + 1 ),
	   sales [0][i], sales [1][i], sales [2][i], sales [3][i],
	  (sales [0][i]+ sales [1][i]+ sales [2][i]+ sales [3][i]) );
   }

   printf("\n%68s","");
   printf("\n%s%s","----------------------------------------",
		   "---------------------------------------");
   printf("\n\n%14s%12lu%13lu%13lu%13lu\n\n\n","Total ($):",
	   (sales [0][0]+sales [0][1]+sales [0][2]+sales [0][3]+sales [0][4]),
	   (sales [1][0]+sales [1][1]+sales [1][2]+sales [1][3]+sales [1][4]),
	   (sales [2][0]+sales [2][1]+sales [2][2]+sales [2][3]+sales [2][4]),
	   (sales [3][0]+sales [3][1]+sales [3][2]+sales [3][3]+sales [3][4]) );
  } /* end of if */

 return 0;
}