/* Exercise 6.11_a */
/* This program sorts an array's values */
/* into ascending order with optimization. */
/* by this way, 45 comparisons made instead of 81. */

#include <stdio.h>
#include <conio.h>

# define SIZE 10

main()
{
int a[SIZE] = { 2, 6, 4, 8, 10, 12, 89, 68, 45, 37 };
int i, pass, hold, counter = 0;

 clrscr();
 printf("\nData items in original order:\n");

 for ( i = 0 ; i <= SIZE - 1 ; i++ )         /* print the original order */
  printf("%4d", a[i]);

 printf("\n");

 for ( pass = 1 ; pass <= SIZE - 1 ; pass++ )                  /* passes */
  {
   for ( i = 0 ; i <= SIZE - pass - 1 ; i++ )      /* one pass (reduced) */
    {
     if ( a[i] > a[i+1] )                              /* one comparison */
      {
       hold = a[i];                                          /* one swap */
       a[i] = a[i+1];
       a[i+1] = hold;
      }
     counter++;                            /* count the comparisons made */
    }
  }

 printf("\n%d comparison(s) made...\n", counter);
 printf("\nData items in ascending order:\n");

 for ( i = 0 ; i <= SIZE - 1 ; i++ )           /* print the sorted array */
  printf("%4d", a[i]);

 printf("\n\n");
 return 0;
}


